﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace WinFormInvoke
{
   public class Invoker
   {
        public delegate void CallbackFunc(string msg);
        public CallbackFunc AsynCallback;
                 
        public Invoker(CallbackFunc callback)
        {
            AsynCallback = callback;
        }

        public virtual void TheadMethod(int amount)
        {
            this.AsynCallback("线程开始");
            for (int i = 0; i < amount; i++)
            {
                this.AsynCallback(i.ToString());               
                Thread.Sleep(1000);
            }

            this.AsynCallback("线程结束");
        }

        public virtual void DoThread(int amount)
        {
            Thread t = new Thread(new ThreadStart(delegate
            {
                TheadMethod(amount);
            }));

            t.Start();
        }
    }
}
