﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WinFormInvoke
{
    public partial class frMain : Form
    {
        Invoker Invoker;

        public frMain()
        {
            InitializeComponent();
        } 

        private void frMain_Load(object sender, EventArgs e)
        {
            Invoker = new Invoker(AsynUpdateTxtMethod);
        }

        public void UpdateTxtMethod(string msg)
        {
            tbResult.AppendText(msg + "\r\n");
            tbResult.ScrollToCaret();
        }

        public void AsynUpdateTxtMethod(string msg)
        {
            if (tbResult.InvokeRequired)
            {
                this.BeginInvoke(new Invoker.CallbackFunc(UpdateTxtMethod), msg);
            }
            else
            {
                UpdateTxtMethod(msg);
            }
        } 

        private void btnStart_Click(object sender, EventArgs e)
        {
            Invoker.DoThread(int.Parse(tbAmount.Text.Trim()));
        } 
    }
}
